# model_server

This repository tracks the model_server project for adaptive feedback microscopy

# Installation on Windows

1. Install Git:<br>https://git-scm.com/download/win
2. Install Miniforge for environment management:<br>https://github.com/conda-forge/miniforge/releases/latest/download/Miniforge-pypy3-Windows-x86_64.exe
3. Under the Start menu, open `Miniforge3 > Miniforge Prompt`
4. In the new terminal, clone the model_server repository:<br>
   `cd %userprofile%`<br>
   `git clone https://almf-staff:KJmFvyPRbpzoVZDqfMzV@git.embl.de/rhodes/model_server.git`
6. Open the newly created model_server project root: `cd model_server`
7. Create the environment: `mamba env create --file requirements.yml --name model_server_env`
8. Activate the environment: `mamba activate model_server_env`
9. Add the project source as a Python package: `pip install -e .`

# Start the server
Simply click "start_server.bat" in the model_server directory.  This should open a terminal that reports server requests, as well as a browser with a status confirmation page.  To stop the server, type "stop" in the terminal.

# Project subfolders

## /doc
User-facing documentation (currently empty)

## /tests
Python unit tests that must pass prior to PR, either by a manual or CI/CD workflow

## /clients
Modules that implement HTTP client behavior, i.e. map image processing operations to model_server endpoints

## /clients/imagej
Scripts internal to model_server that specifically depend on the ImageJ API.  If \*.py, assume Python 2.7 in ImageJ Jython interpreter

## /confs
Default configuration files that point to test data, dependency search paths, etc.

## /extensions
Python that extends model_server

## /extensions/ilastik
Specific models and pipelines that use ilastik workflows

## /scripts
Command line scripts e.g. to execute batch data processing, install local files, or manage server runtime behavior.

